--- libgui/graphics/GLCanvas.cc	Mon Nov 07 15:48:46 2016 -0800
+++ libgui/graphics/GLCanvas.cc	Mon Nov 07 23:45:41 2016 -0800
@@ -30,6 +30,9 @@
 #include "GLCanvas.h"
 #include "gl-select.h"
 
+#include <qapplication.h>
+#include <QScreen>
+
 namespace QtHandles
 {
 
@@ -47,6 +50,9 @@
   {
     setFocusPolicy (Qt::ClickFocus);
     setFocus();
+
+    QScreen *screen = QApplication::screens().at(0);
+    gh_manager::screen_scale = screen->devicePixelRatio();
   }
 
   GLCanvas::~GLCanvas (void)
--- libinterp/corefcn/gl-render.cc	Mon Nov 07 15:48:46 2016 -0800
+++ libinterp/corefcn/gl-render.cc	Mon Nov 07 23:45:41 2016 -0800
@@ -1119,7 +1119,7 @@
     glMultMatrixd (x_mat1.data ());
     glMatrixMode (GL_PROJECTION);
     glLoadIdentity ();
-    glOrtho (0, vw[2], vw[3], 0, xZ1, xZ2);
+    glOrtho (0, roundf((1./gh_manager::screen_scale)*(float)vw[2]), roundf((1./gh_manager::screen_scale)*(float)vw[3]), 0, xZ1, xZ2);
     glMultMatrixd (x_mat2.data ());
     glMatrixMode (GL_MODELVIEW);
 
@@ -3482,7 +3482,7 @@
   {
 #if defined (HAVE_OPENGL)
 
-    glViewport (0, 0, w, h);
+    glViewport (0.0, 0.0, gh_manager::screen_scale*w, gh_manager::screen_scale*h);
 
 #else
 
@@ -3587,7 +3587,7 @@
     txt_renderer.set_font (props.get ("fontname").string_value (),
                            props.get ("fontweight").string_value (),
                            props.get ("fontangle").string_value (),
-                           props.get ("fontsize_points").double_value ());
+                           gh_manager::screen_scale*props.get ("fontsize_points").double_value ());
   }
 
   void
@@ -3775,7 +3775,7 @@
     glMatrixMode (GL_PROJECTION);
     glPushMatrix ();
     glLoadIdentity ();
-    glOrtho (0, vw[2], vw[3], 0, xZ1, xZ2);
+    glOrtho (0, roundf((1./gh_manager::screen_scale)*(float)vw[2]), roundf((1./gh_manager::screen_scale)*(float)vw[3]), 0, xZ1, xZ2);
     glMatrixMode (GL_MODELVIEW);
     glPushMatrix ();
 
--- libinterp/corefcn/graphics.cc	Mon Nov 07 15:48:46 2016 -0800
+++ libinterp/corefcn/graphics.cc	Mon Nov 07 23:45:41 2016 -0800
@@ -6271,7 +6271,7 @@
   txt_renderer.set_font (get ("fontname").string_value (),
                          get ("fontweight").string_value (),
                          get ("fontangle").string_value (),
-                         get ("fontsize_points").double_value ());
+                         gh_manager::screen_scale*get ("fontsize_points").double_value ());
 }
 
 // The INTERNAL flag defines whether position or outerposition is used.
@@ -8048,7 +8048,7 @@
   txt_renderer.set_font (get ("fontname").string_value (),
                          get ("fontweight").string_value (),
                          get ("fontangle").string_value (),
-                         get ("fontsize_points").double_value ());
+                         gh_manager::screen_scale*get ("fontsize_points").double_value ());
 
   txt_renderer.set_color (get_color_rgb ());
 }
@@ -9239,6 +9239,8 @@
   return parent_go.get_factory_default (type () + name);
 }
 
+float gh_manager::screen_scale = 1.0;
+
 // We use a random value for the handle to avoid issues with plots and
 // scalar values for the first argument.
 gh_manager::gh_manager (void)
--- libinterp/corefcn/graphics.in.h	Mon Nov 07 15:48:46 2016 -0800
+++ libinterp/corefcn/graphics.in.h	Mon Nov 07 23:45:41 2016 -0800
@@ -6054,6 +6054,8 @@
 
 public:
 
+  static float screen_scale;
+
   static void create_instance (void);
 
   static bool instance_ok (void)
